## gridtools 1.1.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14.5)

cmake_policy(SET CMP0048 NEW)
file(STRINGS "version.txt" __GT_VERSION)
project(GridTools VERSION ${__GT_VERSION} LANGUAGES CXX)
unset(__GT_VERSION)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")

include(CTest)

# ===============
# Load some cmake modules.
# 1) define what flags should be available,

include(detect_features)
detect_cuda()
detect_openmp()
detect_mpi()

include(flags)

if(POLICY CMP0060)
    # Policy to avoid cmake to substitute libraries with paths and extensions with -l<libname>
    cmake_policy(SET CMP0060 NEW)
endif()

# ===============
# Load some cmake modules.
# 2) package by name finder
# 3) testing methods
# 4) build configurator (include path, compiler flags, etc.
# ===============
include(definitions)
if (BUILD_TESTING)
    include(testing)
endif()

include(FetchContent)
FetchContent_Declare(
    cpp_bindgen
    GIT_REPOSITORY https://github.com/GridTools/cpp_bindgen.git
    GIT_TAG        v1.0.0
    )
# Enable legacy mode for CPP_BINDGEN for users of GT 1.0
# TODO remove in GT 2.0
set(CPP_BINDGEN_GT_LEGACY ON)
set(build_testing_ ${BUILD_TESTING})
set(BUILD_TESTING OFF)
FetchContent_MakeAvailable(cpp_bindgen)
set(BUILD_TESTING ${build_testing_})

add_subdirectory(src)

# ===============
# tests
# ===============
if(BUILD_TESTING)
    add_subdirectory(regression)
    add_subdirectory(unit_tests)

    add_subdirectory(docs_src/manuals/getting_started)
endif()

# ===============
# examples
# ===============
if(GT_INSTALL_EXAMPLES)
    add_subdirectory(examples)
endif()

# ===============
# Downloads the gridtools_experimental repository
# ===============
if(GT_ENABLE_EXPERIMENTAL_REPOSITORY)
    include(gridtools_experimental/download_gridtools_experimental)
endif()

# ===============
# Python scripts
# ===============
if(GT_ENABLE_PYUTILS)
    add_subdirectory(pyutils)
endif()

# absolute path to avoid collision with "export" from other packages
include(${CMAKE_CURRENT_LIST_DIR}/cmake/export.cmake)

=== examples/CMakeLists.txt ===
# This file is part of the GridTools source tree to drive installation of the examples.

function(install_example)
    set(options)
    # - if needed later split into mc and cuda sources (then add extension)
    set(one_value_args DIRECTORY)
    set(multi_value_args SOURCES)
    cmake_parse_arguments(ARG "${options}" "${one_value_args};" "${multi_value_args}" ${ARGN})

    string(REPLACE ";" " " EXAMPLES_SRCFILES "${ARG_SOURCES}")
    configure_file(cmake_skeletons/CMakeLists.txt.example.in ${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/${ARG_DIRECTORY}/CMakeLists.txt @ONLY)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/${ARG_DIRECTORY}/CMakeLists.txt DESTINATION ${GT_INSTALL_EXAMPLES_PATH}/${ARG_DIRECTORY})
    install(
        DIRECTORY ${ARG_DIRECTORY}
        DESTINATION ${GT_INSTALL_EXAMPLES_PATH}
        )

    list(APPEND enabled_examples ${ARG_DIRECTORY})
    set(enabled_examples ${enabled_examples} PARENT_SCOPE)
endfunction()

if(GT_INSTALL_EXAMPLES)
    set(enabled_examples) # used in CMakeLists.txt.in, filled in install_example()
    install_example(DIRECTORY stencil_composition SOURCES copy_stencil horizontal_diffusion_limited tridiagonal_solver)

    configure_file(stencil_computation/CMakeLists.txt.in
        ${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/stencil_computation/CMakeLists.txt @ONLY)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/stencil_computation/CMakeLists.txt
        DESTINATION ${GT_INSTALL_EXAMPLES_PATH}/stencil_computation)
    install(
        DIRECTORY stencil_computation
        DESTINATION ${GT_INSTALL_EXAMPLES_PATH}
        PATTERN "CMakeLists.txt.in" EXCLUDE
        )
    list(APPEND enabled_examples stencil_computation)

    install_example(DIRECTORY boundary_conditions SOURCES boundary_conditions boundary_conditions_provided)

    # If clang+nvcc, we disable the c-bindings test, if CUDA < 10.0 because nvcc has problems with C++14 in this combination
    if(NOT ("${CMAKE_CXX_COMPILER_ID}" STREQUAL Clang AND DEFINED CMAKE_CUDA_COMPILER AND "${CMAKE_CUDA_COMPILER_VERSION}" VERSION_LESS "10.0"))
        configure_file(c_bindings/CMakeLists.txt.in
            ${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/c_bindings/CMakeLists.txt @ONLY)
        install(FILES ${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/c_bindings/CMakeLists.txt
            DESTINATION ${GT_INSTALL_EXAMPLES_PATH}/c_bindings)
        install(
            DIRECTORY c_bindings
            DESTINATION ${GT_INSTALL_EXAMPLES_PATH}
            PATTERN "CMakeLists.txt.in" EXCLUDE
            )
        list(APPEND enabled_examples c_bindings)
    endif()

    configure_file(cmake_skeletons/CMakeLists.txt.driver.in ${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/CMakeLists.txt @ONLY)
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/CMakeLists.txt DESTINATION ${GT_INSTALL_EXAMPLES_PATH})

    install(FILES ${PROJECT_SOURCE_DIR}/cmake/workaround_check_language.cmake DESTINATION ${GT_INSTALL_EXAMPLES_PATH})
endif()

=== pyutils/CMakeLists.txt ===
string(TOLOWER "${CMAKE_BUILD_TYPE}" PYUTILS_BUILD_TYPE)

if(GT_ENABLE_BACKEND_CUDA)
    if (GT_CUDA_COMPILATION_TYPE MATCHES "NVCC-CUDA")
        set(PYUTILS_COMPILER "${CMAKE_CUDA_COMPILER} ${CMAKE_CUDA_COMPILER_VERSION} (${CMAKE_CXX_COMPILER} ${CMAKE_CXX_COMPILER_VERSION})")
    else()
        set(PYUTILS_COMPILER "${CMAKE_CXX_COMPILER} ${CMAKE_CXX_COMPILER_VERSION} (${CMAKE_CUDA_COMPILER} ${CMAKE_CUDA_COMPILER_VERSION})")
    endif()
else()
    set(PYUTILS_COMPILER "${CMAKE_CXX_COMPILER} ${CMAKE_CXX_COMPILER_VERSION}")
endif()

if(GT_SINGLE_PRECISION)
    set(PYUTILS_PRECISION "float")
else()
    set(PYUTILS_PRECISION "double")
endif()

if(GT_TESTS_ICOSAHEDRAL_GRID)
    set(PYUTILS_GRID "icosahedral")
else()
    set(PYUTILS_GRID "structured")
endif()

if(GT_ENABLE_BACKEND_X86)
    list(APPEND PYUTILS_BACKEND "x86")
endif()

if(GT_ENABLE_BACKEND_NAIVE)
    list(APPEND PYUTILS_BACKEND "naive")
endif()

if(GT_ENABLE_BACKEND_CUDA)
    list(APPEND PYUTILS_BACKEND "cuda")
endif()

if(GT_ENABLE_BACKEND_MC)
    list(APPEND PYUTILS_BACKEND "mc")
endif()

file(COPY . DESTINATION . FILES_MATCHING PATTERN *.py)
configure_file(pyutils/buildinfo.py.in pyutils/buildinfo.py)

=== regression/CMakeLists.txt ===
if(GT_TESTS_ICOSAHEDRAL_GRID)
    add_subdirectory(icosahedral)
else()

    set(SOURCES_PERFTEST
        horizontal_diffusion
        horizontal_diffusion_fused
        simple_hori_diff
        copy_stencil
        vertical_advection_dycore
        advection_pdbott_prepare_tracers
        layout_transformation
        boundary_conditions
        )
    set(SOURCES
        ${SOURCES_PERFTEST}
        laplacian positional_stencil
        tridiagonal
        alignment
        extended_4D
        expandable_parameters
        expandable_parameters_single_kernel
        horizontal_diffusion_functions
        )

    # special target for executables which are used from performance benchmarks
    add_custom_target(perftests)

    if(GT_ENABLE_BACKEND_X86)
        foreach(srcfile IN LISTS SOURCES)
            add_executable(${srcfile}_x86 ${srcfile}.cpp)
            target_link_libraries(${srcfile}_x86 regression_main GridToolsTestX86)

            gridtools_add_test(
                NAME tests.${srcfile}_x86_12_33_61
                COMMAND $<TARGET_FILE:${srcfile}_x86> 12 33 61
                LABELS regression_x86 backend_x86
                )
            gridtools_add_test(
                NAME tests.${srcfile}_x86_23_11_43
                COMMAND $<TARGET_FILE:${srcfile}_x86> 23 11 43
                LABELS regression_x86 backend_x86
                )

            if (srcfile IN_LIST SOURCES_PERFTEST)
                add_dependencies(perftests ${srcfile}_x86)
                set_property(TEST tests.${srcfile}_x86_23_11_43 APPEND PROPERTY LABELS perftests_x86)
            endif()
        endforeach(srcfile)

        if(GT_USE_MPI)
            add_custom_mpi_test(x86 TARGET copy_stencil_parallel NPROC 4 SOURCES copy_stencil_parallel.cpp)

            ## The next executable is not made into a test since it does not validate.
            ## The numerics need to be fixed (this is a task to be undertaken in the future)
            add_executable(shallow_water_enhanced_x86  shallow_water_enhanced.cpp)
            target_link_libraries(shallow_water_enhanced_x86 gtest_main gcl GridToolsTestX86)
        endif()
    endif(GT_ENABLE_BACKEND_X86)

    if(GT_ENABLE_BACKEND_NAIVE)
        foreach(srcfile IN LISTS SOURCES)
            add_executable(${srcfile}_naive   ${srcfile}.cpp)
            target_link_libraries(${srcfile}_naive regression_main GridToolsTestNAIVE)

            gridtools_add_test(
                NAME tests.${srcfile}_naive_12_33_61
                COMMAND $<TARGET_FILE:${srcfile}_naive> 12 33 21
                LABELS regression_naive backend_naive
                )
            gridtools_add_test(
                NAME tests.${srcfile}_naive_23_11_43
                COMMAND $<TARGET_FILE:${srcfile}_naive> 23 11 43
                LABELS regression_naive backend_naive
                )
        endforeach(srcfile)

        if(GT_USE_MPI)
            add_custom_mpi_test(naive TARGET copy_stencil_parallel NPROC 4 SOURCES copy_stencil_parallel.cpp)

            ## The next executable is not made into a test since it does not validate.
            ## The numerics need to be fixed (this is a task to be undertaken in the future)
            add_executable(shallow_water_enhanced_naive  shallow_water_enhanced.cpp)
            target_link_libraries(shallow_water_enhanced_naive gtest_main gcl GridToolsTestNAIVE)
        endif()
    endif(GT_ENABLE_BACKEND_NAIVE)

    if(GT_ENABLE_BACKEND_MC)
        foreach(srcfile IN LISTS SOURCES)
          add_executable(${srcfile}_mc   ${srcfile}.cpp)
          target_link_libraries(${srcfile}_mc regression_main GridToolsTestMC)

          gridtools_add_test(
              NAME tests.${srcfile}_mc_12_33_61
              COMMAND $<TARGET_FILE:${srcfile}_mc> 12 33 61
              LABELS regression_mc backend_mc
              )
          gridtools_add_test(
              NAME tests.${srcfile}_mc_23_11_43
              COMMAND $<TARGET_FILE:${srcfile}_mc> 23 11 43
              LABELS regression_mc backend_mc
              )
          if (srcfile IN_LIST SOURCES_PERFTEST)
              add_dependencies(perftests ${srcfile}_mc)
              set_property(TEST tests.${srcfile}_mc_23_11_43 APPEND PROPERTY LABELS perftests_mc)
          endif()
        endforeach(srcfile)

        if(GT_USE_MPI)
            add_custom_mpi_test(mc TARGET copy_stencil_parallel NPROC 4 SOURCES copy_stencil_parallel.cpp)

            ## The next executable is not made into a test since it does not validate.
            ## The numerics need to be fixed (this is a task to be undertaken in the future)
            add_executable(shallow_water_enhanced_mc  shallow_water_enhanced.cpp)
            target_link_libraries(shallow_water_enhanced_mc  gtest_main gcl GridToolsTestMC)
        endif()
    endif(GT_ENABLE_BACKEND_MC)

    if(GT_ENABLE_BACKEND_CUDA)

       foreach(srcfile IN LISTS SOURCES)
           add_executable( ${srcfile}_cuda ${srcfile}.cu)
           target_link_libraries(${srcfile}_cuda regression_main GridToolsTestCUDA)
           if(GT_CUDA_COMPILATION_TYPE MATCHES "Clang-CUDA" OR
                   GT_CUDA_COMPILATION_TYPE MATCHES "HIPCC-AMDGPU")
               set_source_files_properties(${srcfile}.cu PROPERTIES LANGUAGE CXX)
           endif()

           gridtools_add_test(
               NAME tests.${srcfile}_cuda_47_38_61
               COMMAND $<TARGET_FILE:${srcfile}_cuda> 47 38 61
               LABELS regression_cuda backend_cuda
               )
           gridtools_add_test(
               NAME tests.${srcfile}_cuda_63_38_10
               COMMAND $<TARGET_FILE:${srcfile}_cuda> 63 38 10
               LABELS regression_cuda backend_cuda
               )
           if(srcfile IN_LIST SOURCES_PERFTEST)
               add_dependencies(perftests ${srcfile}_cuda)
               set_property(TEST tests.${srcfile}_cuda_63_38_10 APPEND PROPERTY LABELS perftests_cuda)
           endif()

           if(GT_CUDA_PTX_GENERATION)
               add_library( ${srcfile}_cuda_ptx OBJECT ${srcfile}.cu)
               target_link_libraries(${srcfile}_cuda_ptx regression_main GridToolsTestCUDA)
               set_target_properties(${srcfile}_cuda_ptx PROPERTIES CUDA_PTX_COMPILATION ON)
           endif()
       endforeach(srcfile)

       if(GT_USE_MPI)
           add_custom_mpi_test(cuda TARGET copy_stencil_parallel NPROC 4 SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/copy_stencil_parallel.cu )

           ## The next executable is not made into a test since it does not validate.
           ## The numerics need to be fixed (this is a task to be undertaken in the future)
           add_executable(shallow_water_enhanced_cuda shallow_water_enhanced.cu)
           target_link_libraries(shallow_water_enhanced_cuda gtest_main gcl GridToolsTestCUDA)
        endif()
    endif(GT_ENABLE_BACKEND_CUDA)

    add_subdirectory( c_bindings )
    add_subdirectory( communication )

endif()

=== src/CMakeLists.txt ===
add_library(gcl
    GCL.cpp
    )
target_link_libraries(gcl PUBLIC gridtools)
if(GT_USE_MPI)
    target_link_libraries(gcl PUBLIC MPI::MPI_CXX)
endif()

install(TARGETS gcl EXPORT GridToolsTargets
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
  RUNTIME DESTINATION bin
  INCLUDES DESTINATION include
)

add_subdirectory(tools)

=== unit_tests/CMakeLists.txt ===
# collect tests
fetch_x86_tests(. LABELS unittest_x86)
fetch_gpu_tests(. LABELS unittest_cuda)

# include all subdirs
add_subdirectory(common)
add_subdirectory(communication)
add_subdirectory(boundary_conditions)
add_subdirectory(distributed_boundaries)
add_subdirectory(stencil_composition)
add_subdirectory(storage)
add_subdirectory(interface)

=== regression/c_bindings/CMakeLists.txt ===
if (GT_ENABLE_BACKEND_X86)
    if(GT_SINGLE_PRECISION)
        set(prec float)
    else()
        set(prec double)
    endif()

    bindgen_add_library(implementation_${prec} SOURCES implementation.cpp FORTRAN_MODULE_NAME implementation)
    target_link_libraries(implementation_${prec} PUBLIC GridToolsTestX86)
    bindgen_enable_fortran_library(implementation_${prec})

    bindgen_add_library(implementation_wrapper_${prec} SOURCES implementation_wrapper.cpp FORTRAN_MODULE_NAME implementation_wrapper)
    target_link_libraries(implementation_wrapper_${prec} PUBLIC GridToolsTestX86)
    bindgen_enable_fortran_library(implementation_wrapper_${prec})

    if (CMAKE_C_COMPILER_LOADED)
        add_executable(driver driver.c)
        target_link_libraries(driver implementation_${prec}_c)
    endif()

    if (CMAKE_Fortran_COMPILER_LOADED)
        include(fortran_helpers)

        add_executable(fdriver fdriver.f90)
        target_link_libraries(fdriver implementation_${prec}_fortran)
        set_target_properties(fdriver PROPERTIES LINKER_LANGUAGE Fortran)
        bindgen_enable_fortran_preprocessing_on_target(fdriver)

        add_executable(fdriver_wrapper fdriver_wrapper.f90)
        target_link_libraries(fdriver_wrapper implementation_wrapper_${prec}_fortran)
        set_target_properties(fdriver_wrapper PROPERTIES LINKER_LANGUAGE Fortran)
        bindgen_enable_fortran_preprocessing_on_target(fdriver_wrapper)
    endif()
endif(GT_ENABLE_BACKEND_X86)

=== regression/communication/CMakeLists.txt ===
### Executables
if(NOT GT_GCL_ONLY)

  ### L2
  if( GT_USE_MPI )
    foreach(srcfile
            test_all_to_all_halo_3D
            test_halo_exchange_3D_all
            test_halo_exchange_3D_all_2
            test_halo_exchange_3D_all_3
            test_halo_exchange_3D_generic
            test_halo_exchange_3D_generic_full
            )
      add_executable( ${srcfile} ${srcfile}.cpp)
      target_link_libraries(${srcfile} gtest gcl mpi_gtest_main )
      target_compile_definitions(${srcfile} PRIVATE STANDALONE)
    endforeach(srcfile)


    if( GT_ENABLE_BACKEND_CUDA )
      if(NOT MSVC)
        foreach(srcfile
                test_halo_exchange_3D_all
                test_halo_exchange_3D_all_2
                test_halo_exchange_3D_all_3
                test_halo_exchange_3D_generic
                test_halo_exchange_3D_generic_full
                )
          add_executable( ${srcfile}_regression_cuda ${srcfile}.cu )
          target_link_libraries( ${srcfile}_regression_cuda gtest gcl mpi_gtest_main GridToolsTestCUDA)
          target_compile_definitions( ${srcfile}_regression_cuda PRIVATE STANDALONE)
        endforeach()
      endif()
    endif()
  endif()
endif()

=== regression/icosahedral/CMakeLists.txt ===
set(SOURCES_PERFTEST
    stencil_on_edges_multiplefields
    stencil_on_cells
    stencil_on_neighcell_of_edges
    stencil_manual_fold
    )
set(SOURCES
    ${SOURCES_PERFTEST}
    copy_stencil_icosahedral
    expandable_parameters_icosahedral
    stencil_on_cells_color
    stencil_on_edges
    stencil_fused
    stencil_on_neighedge_of_cells
    stencil_on_vertices
    curl
    div
    lap
    )

# special target for executables which are used from performance benchmarks
add_custom_target(perftests)

if(GT_ENABLE_BACKEND_X86)
    foreach(srcfile IN LISTS SOURCES)
        add_executable(${srcfile}_x86 ${srcfile}.cpp)
        target_link_libraries(${srcfile}_x86 regression_main GridToolsTestX86)

        gridtools_add_test(
            NAME tests.${srcfile}_x86_12_33_61
            COMMAND $<TARGET_FILE:${srcfile}_x86> 12 33 61
            LABELS regression_x86 backend_x86
            )
        gridtools_add_test(
            NAME tests.${srcfile}_x86_23_11_43
            COMMAND $<TARGET_FILE:${srcfile}_x86> 23 11 43
            LABELS regression_x86 backend_x86
            )

        if (srcfile IN_LIST SOURCES_PERFTEST)
            add_dependencies(perftests ${srcfile}_x86)
        endif()
    endforeach(srcfile)
endif(GT_ENABLE_BACKEND_X86)

if(GT_ENABLE_BACKEND_NAIVE)
    foreach(srcfile IN LISTS SOURCES)
        add_executable(${srcfile}_naive ${srcfile}.cpp)
        target_link_libraries(${srcfile}_naive regression_main GridToolsTestNAIVE)

        gridtools_add_test(
            NAME tests.${srcfile}_naive_12_33_21
            COMMAND $<TARGET_FILE:${srcfile}_naive> 12 33 21
            LABELS regression_naive backend_naive
            )
        gridtools_add_test(
            NAME tests.${srcfile}_naive_23_11_23
            COMMAND $<TARGET_FILE:${srcfile}_naive> 23 11 23
            LABELS regression_naive backend_naive
            )

        if (srcfile IN_LIST SOURCES_PERFTEST)
            add_dependencies(perftests ${srcfile}_naive)
        endif()
    endforeach(srcfile)
endif(GT_ENABLE_BACKEND_NAIVE)

if(GT_ENABLE_BACKEND_CUDA)
    set(CUDA_SEPARABLE_COMPILATION OFF)
    foreach(srcfile IN LISTS SOURCES)
        add_executable( ${srcfile}_cuda ${srcfile}.cu  )
        target_link_libraries(${srcfile}_cuda regression_main GridToolsTestCUDA)

        gridtools_add_test(
            NAME tests.${srcfile}_cuda_77_48_61
            COMMAND $<TARGET_FILE:${srcfile}_cuda> 77 48 61
            LABELS regression_cuda backend_cuda
            )
        gridtools_add_test(
            NAME tests.${srcfile}_cuda_63_55_43
            COMMAND $<TARGET_FILE:${srcfile}_cuda> 63 55 43
            LABELS regression_cuda backend_cuda
            )

        if (srcfile IN_LIST SOURCES_PERFTEST)
            add_dependencies(perftests ${srcfile}_cuda)
        endif()
    endforeach(srcfile)
endif(GT_ENABLE_BACKEND_CUDA)

=== src/tools/CMakeLists.txt ===
if(BUILD_TESTING)
    add_library(regression_main regression_fixture.cpp)
    target_link_libraries(regression_main gtest gridtools)
endif()

=== unit_tests/boundary_conditions/CMakeLists.txt ===
# collect test cases
fetch_x86_tests(. LABELS unittest_x86 )
fetch_mc_tests(. LABELS unittest_mc)
fetch_gpu_tests(. LABELS unittest_cuda)

# collect structured grid specific tests
if(NOT GT_TESTS_ICOSAHEDRAL_GRID)
    fetch_x86_tests(structured_grids LABELS unittest_x86)
    fetch_mc_tests(structured_grids LABELS unittest_mc)
    fetch_gpu_tests(structured_grids LABELS unittest_cuda)
endif()

# collect icosahedral grid specific tests
if (GT_TESTS_ICOSAHEDRAL_GRID)
    fetch_x86_tests(icosahedral_grids LABELS unittest_x86)
    fetch_mc_tests(icosahedral_grids LABELS unittest_mc)
    fetch_gpu_tests(icosahedral_grids LABELS unittest_cuda)
endif()

=== unit_tests/common/CMakeLists.txt ===
# collect all tests in current folder
fetch_x86_tests(. LABELS unittest_x86 )
fetch_mc_tests(. LABELS unittest_mc )
fetch_gpu_tests(. LABELS unittest_cuda )

# collect all tests in generic_metafunctions folder
fetch_x86_tests(generic_metafunctions LABELS unittest_x86 )
fetch_mc_tests(generic_metafunctions LABELS unittest_mc )
fetch_gpu_tests(generic_metafunctions LABELS unittest_cuda )

=== debian/changelog ===
gridtools (1.1.3-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 26 Jan 2020 14:03:16 +0000

=== debian/control ===
Source: gridtools
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 12), 
  dh-buildinfo,  
  ecbuild,
  gfortran | fortran-compiler,
  doxygen,
  mpi-default-dev,
  libboost-dev (>= 1.58.0)
Standards-Version: 4.4.1.0
Homepage: https://gridtools.github.io/gridtools/latest/index.html
Vcs-Browser: https://salsa.debian.org:/science-team/gridtools.git
Vcs-Git: https://salsa.debian.org:/science-team/gridtools.git

Package: libgridtools-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, 
 ecbuild, 
 mpi-default-dev,
 libboost-dev (>= 1.58.0)
Description: Framework for storage and computation on Weather and Climate Grids
 The GridTools (GT) framework is a set of libraries and utilities to develop
 performance portable applications in which stencil operations on grids are
 central.  It provides regular and block-structured grids commonly found in the
  weather and climate application field, addresses the challenges that arise
 from integration into production code, such as the expression of boundaryi
 conditions, or conditional execution. The framework is structured such that
 it can be called from different weather models or programming interfaces,
 and can target various computer architectures. This is achieved by separating
 the GT core library in a user facing part (frontend) and architecture specific
 (backend) parts. The core library also abstracts various possible data layouts
 and applies optimizations on stages with multiple stencils.
 The core library is complemented by facilities to interoperate with other 
 languages (such as C and Fortran), to aid code development and a communication
 layer.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
INSTDIR:=debian/libgridtools-dev
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)

NO_NATIVE_ARCHS := powerpc ppc64el ppc64 riscv64 sh4 s390x  hppa m68k mipsel
NATIVE :=   $(if $(filter $(DEB_TARGET_ARCH), $(NO_NATIVE_ARCHS)), \
	 -DGT_ENABLE_BACKEND_X86=Off -DGT_ENABLE_BACKEND_NAIVE=Off ) 


BUILD_FLAGS = \
	-DCMAKE_MODULE_PATH=/usr/share/ecbuild/cmake \
	-DINSTALL_GTEST=Off \
	-DBUILD_TESTING=Off $(NATIVE)

# Test suite requires 4 processors. Fake it on OpenMPI
export OMPI_MCA_rmaps_base_oversubscribe=1

%:
	dh $@ --buildsystem=cmake 

override_dh_auto_configure:
	dh_auto_configure -- ${BUILD_FLAGS} 


override_dh_auto_install:
	dh_auto_install
	# Shuffle to correct locations
	install -d $(INSTDIR)/$(LIBDIR)/cmake
	install -d $(INSTDIR)/usr/share/doc/libgridtools-dev
	mv $(INSTDIR)/usr/lib/libgcl.a $(INSTDIR)/$(LIBDIR)
	mv $(INSTDIR)/usr/lib/cmake $(INSTDIR)/$(LIBDIR)/cmake/gridtools
	mv $(INSTDIR)/usr/gridtools_examples $(INSTDIR)/usr/share/doc/libgridtools-dev

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/libaec-$1\.tar\.gz/ \
  https://github.com/GridTools/gridtools/tags .*/v?(\d\S+)\.tar\.gz

## gridtools 2.0.0~rc1

=== debian/changelog ===
gridtools (2.0.0~rc1-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 30 Jun 2020 14:20:54 +0100

gridtools (1.1.3-2) unstable; urgency=medium

  * Standards-Version: 4.5.0
  * Fix paths in generated cmake files

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 02 Apr 2020 14:31:33 +0100

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
   doxygen,
   mpi-default-dev,
   libboost-dev (>= 1.58.0)
-Standards-Version: 4.4.1.0
+Standards-Version: 4.5.0
 Homepage: https://gridtools.github.io/gridtools/latest/index.html
 Vcs-Browser: https://salsa.debian.org:/science-team/gridtools.git
 Vcs-Git: https://salsa.debian.org:/science-team/gridtools.git

=== debian/rules ===
--- 
+++ 
@@ -7,6 +7,7 @@
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 INSTDIR:=debian/libgridtools-dev
 LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
+CMAKE_DIR:=$(INSTDIR)/$(LIBDIR)/cmake/gridtools
 
 NO_NATIVE_ARCHS := powerpc ppc64el ppc64 riscv64 sh4 s390x  hppa m68k mipsel
 NATIVE :=   $(if $(filter $(DEB_TARGET_ARCH), $(NO_NATIVE_ARCHS)), \
@@ -27,7 +28,6 @@
 override_dh_auto_configure:
 	dh_auto_configure -- ${BUILD_FLAGS} 
 
-
 override_dh_auto_install:
 	dh_auto_install
 	# Shuffle to correct locations
@@ -36,3 +36,15 @@
 	mv $(INSTDIR)/usr/lib/libgcl.a $(INSTDIR)/$(LIBDIR)
 	mv $(INSTDIR)/usr/lib/cmake $(INSTDIR)/$(LIBDIR)/cmake/gridtools
 	mv $(INSTDIR)/usr/gridtools_examples $(INSTDIR)/usr/share/doc/libgridtools-dev
+	for d in \
+                $(CMAKE_DIR)/GridToolsConfig.cmake \
+                $(CMAKE_DIR)/GridToolsTargets-none.cmake ; do \
+                cat $$d | \
+                        sed -e 's%$${_IMPORT_PREFIX}/include%$(INCDIR)%g' | \
+                        sed -e 's%$${_IMPORT_PREFIX}/lib%$(LIBDIR)%g' | \
+                        sed -e 's%$${_IMPORT_PREFIX}/bin%/usr/bin%g' | \
+                        sed -e 's%$${PACKAGE_PREFIX_DIR}/lib/cmake%$(LIBDIR)/cmake/gridtools%g' | \
+                > $(CMAKE_DIR)/tmp ; \
+                mv $(CMAKE_DIR)/tmp $$d ; \
+                done
+
